
//	gcc -m64 -shared tangentv_lib.c -o tangentv_lib.so

int CC_Boundaries(int* labels, int width, int height, int count_labels,
                  int* out_mins_y, int* out_maxs_y, int* out_mins_x, int* out_maxs_x,
                  int* out_counts)
{

    //Initialize output ...
    int i;
    for (i = 0;  i < count_labels; i++)
    {
        out_mins_y[i] = height;
        out_maxs_y[i] = 0;

        out_mins_x[i] = width;
        out_maxs_x[i] = 0;

        out_counts[i] = 0;
    }

    int x, y;
    int idx = 0;
    for (y = 0; y < height; y++)
    {
        for (x = 0; x < width; x++)
        {
            if (labels[idx] > 0){
                int cc_id = labels[idx] - 1;

                if (out_mins_y[cc_id] > y){
                    out_mins_y[cc_id]  = y;
                }

                if (out_maxs_y[cc_id] < y){
                    out_maxs_y[cc_id] = y;
                }

                if (out_mins_x[cc_id] > x){
                    out_mins_x[cc_id]  = x;
                }

                if (out_maxs_x[cc_id] < x){
                    out_maxs_x[cc_id] = x;
                }

                out_counts[cc_id]++;
            }
            idx ++;
        }
    }

    return 0;
}
