
import sys

from TangentV.evaluation.bbox_evaluator import BBoxEvaluator

def main():
    if len(sys.argv) < 3:
        print("Usage:")
        print("")
        print(" python tanv_03_eval_target_MRR.py bbox_file bbox_gt [unjudged]")
        print("\tbbox_file\tQuery results Bounding Box file generated by search")
        print("\tbbox_gt\tEvaluated results in Bounding Box format")
        print("\tunjudged\tOptional, store unjudged results in a new file")
        print("")
        print("Bounding Box Ground Truth Format:")
        print("\tQuery ID\tLocation ID\tX\tY\tW\tH\tIs Target")
        return

    results_bbox_filename = sys.argv[1]
    gt_bbox_filename = sys.argv[2]
    if len(sys.argv) >= 4:
        unjudged_filename = sys.argv[3]
    else:
        unjudged_filename = None

    # load BBox file
    results_bboxes = BBoxEvaluator.load_BBox_results(results_bbox_filename)

    # load GT BBox file
    gt_bboxes = BBoxEvaluator.load_BBox_ground_truth(gt_bbox_filename)

    overall, per_query = BBoxEvaluator.get_MRR(results_bboxes, gt_bboxes, 0.5, True)

    BBoxEvaluator.display_MRR(overall, per_query)

    if len(overall["unjudged"]) > 0 and unjudged_filename is not None:
        BBoxEvaluator.save_BBox_unjudged(unjudged_filename, overall["unjudged"])

        print("\nMissing Bounding Boxes saved at: " + unjudged_filename)


if __name__ == '__main__':
    main()
